ents = {}
ents.objects = {}
ents.objpath = "entities/"
local register = {}
local id = 0


function ents.Startup()
	register["wooden_crate"] = love.filesystem.load( ents.objpath .. "wooden_crate.lua" )
end


function ents.Derive(name)
	return love.filesystem.load( ents.objpath .. name .. ".lua" )()
end


function ents.Create(name, x, y, direction)
	if not x then
		x = 0
	end
	
	if not y then
		y = 0
	end

	if not direction then
		direction = " "
	end
	
	if register[name] then
		id = id + 1
		local ent = register[name]()
		ent:load( x, y , direction)
		ent:setPos( x, y )
		ent.id = id
		ents.objects[#ents.objects + 1] = ent
		return ents.objects[#ents.objects]
	else
	print("Error: Entity " .. name .. " does not exist! Snap!")
		return false
	end
end


function ents.update(dt)
	for i, ent in pairs(ents.objects) do
		if ent.update then
			ent:update(dt)
		end
	end
end


function ents.draw()
	for i, ent in pairs(ents.objects) do
		if ent.draw then
			ent:draw()
		end
	end
end